"use strict";var eventDelegation = require("./event-delegation");
var delegateEvent = eventDelegation.aQ_;
var getEventFromEl = eventDelegation.aR_;

// var componentsUtil = require('@internal/components-util');
// var destroyNodeRecursive = componentsUtil.___destroyNodeRecursive;
// var destroyComponentForNode = componentsUtil.___destroyComponentForNode;

function handleNodeAttach(node, componentsContext) {
  if (node.nodeType === 1) {
    var eventName = "onattach";
    var target = getEventFromEl(node, eventName);
    if (target) {
      var out = componentsContext.r_;
      var data = out.data;

      var attachTargets = data.aS_;
      if (!attachTargets) {
        attachTargets = data.aS_ = [];
        out.on("aN_", function () {
          for (var i = 0; i < attachTargets.length; i += 2) {
            var node = attachTargets[i];
            var target = attachTargets[i + 1];
            delegateEvent(node, eventName, target, {});
          }
        });
      }

      attachTargets.push(node);
      attachTargets.push(target);
    }
  }
}

function handleNodeDetach(node) {
  if (node.nodeType === 1) {
    var eventName = "ondetach";
    var target = getEventFromEl(node, eventName);
    if (target) {
      var allowDetach;

      delegateEvent(node, eventName, target, {
        preventDefault: function () {
          allowDetach = false;
        },
        detach: function () {
          var parentNode = node.parentNode;
          if (parentNode) {
            parentNode.removeChild(node);
          }
        }
      });

      return allowDetach;
    }
  }
}

eventDelegation.aT_ = handleNodeAttach;
eventDelegation.am_ = handleNodeDetach;